/*
 * Ext JS Library 2.0 Dev 5
 * Copyright(c) 2006-2007, Ext JS, LLC.
 * licensing@extjs.com
 * 
 * This code has not yet been licensed for use.
 */

Ext.onReady(function(){

    var step = parseInt(Ext.getDom('step').className, 10);
    
    var main = new Ext.Panel({
        id:'ext-training',
        layout: 'table',
        frame:true,
        items:[{
            xtype: 'button',
            text: 'Back',
            disabled : step === 1,
            handler: function(){
                window.location = 'index.php?step=' + (step-1)
            }
        },{
            xtype: 'button',
            text: 'Next',
            disabled : step === 7,
            handler: function(){
                window.location = 'index.php?step=' + (step+1)
            }
        }]
    });

    var bd = Ext.getBody();
    main.render(bd);
    var panelEl = main.getEl();
    panelEl.anchorTo(document, 't-t', [0, -1]);

    var active = false;
    bd.on('mousemove', function(e){
        if(e.getPageY() <= 40 && panelEl.getRegion().contains(e.getPoint()) && !active){
            active = true;
            panelEl.stopFx();
            panelEl.slideIn('t', {duration:.3, easing:'easeOut'});
        }else if(e.getPageY() > 40 && !panelEl.getRegion().contains(e.getPoint()) && active){
            active = false;
            panelEl.stopFx();
            panelEl.slideOut('t', {duration:.3, easing:'easeIn'});
        }
    });
});