﻿<%@ WebHandler Language="C#" Class="Create" %>

using System;
using System.Collections.Generic;
using System.Web;
using App_Code;

public class Create : IHttpHandler {
    
    public void ProcessRequest (HttpContext context) {

        // coming in:  {"Username":"abc","FirstName":"df","LastName":"dfdf","Email":"dfdf","ProviderUserKey":"ext-record-1"}
        string rows = context.Request["rows"];
        if (rows.StartsWith("{"))
        {
            rows = "[" + rows + "]";
        }
        var result = rows.FromJson<List<UserResult>>();
        var userManager = new UserManager();
        userManager.Create(ref result);

        // response should look like this
        // {"success":true,"message":"create","data":{"last":"asdfsadfsadfsadf","first":"asdfasfdasfdasf","id":134,"email":"asdfasfasf"}}
        
              var o = new
        {
            success = true,
            message = "create",
            rows = result
        };
        string retString = o.ToJson();
        HttpContext.Current.Response.Write(retString);
    }
 
    public bool IsReusable {
        get {
            return false;
        }
    }

}