Ext.BLANK_IMAGE_URL = '../resources/images/default/s.gif';
Ext.TabPanel.override({
	border: false,
	resizeTabs: true
});


Ext.onReady(function(){
	Ext.QuickTips.init();
	var tree = new Twc.CategoryTreePanel({
		region: 'west',
		width: 200,
		split: true,
		collapsible: true		
	});

	var tree2 = new Twc.CategoryTreePanel({
		region: 'east',
		title: 'Changed!',
		width: 400,
		split: false,
		collapsible: true		
	});
	
	
	var form = new Ext.FormPanel({
	    title: 'New Product',
	    labelWidth: 75,
	    border:false,
		bodyStyle: 'padding: 10px;',
		defaults: {
			width: 130
		},
	    defaultType: 'textfield',
	    items: [{
	        fieldLabel: 'Product SKU',
	        name: 'sku',
	        allowBlank:false
	    },{
	        fieldLabel: 'Price',
	        name: 'price'
	    }, 
	        new Ext.form.DateField({
	            fieldLabel: 'Expires',
	            name: 'expires'
	        })
	    ],
	    buttons: [{
	        text: 'Save'
	    },{
	        text: 'Cancel'
	    }]
	});			
	
	var tabs = new Ext.TabPanel({
	    border:false,
	    resizeTabs:true,
	    enableTabScroll:true,
	    activeItem:0,
	    defaults:{
	        autoScroll:true
	    },
	    items:[{
			xtype: 'productgrid',
			store: new Twc.ProductStore({
				storeId: 'productStore',
				url: Constants.ServerUrls.loadProductStore,
				root: 'records',
				autoLoad: true
			})			
		},{xtype: 'productform', showDateField: true}, {xtype: 'productform'}]
	});			
	
   /* var vp = new Ext.Viewport({
		layout: 'border',
		items: [tree,tree2
		,{
			region: 'center',
			title: 'Content',
			layout: 'fit',
			items: [tabs]
		},{
			region: 'south',
			title: 'South',
			height: 150,
			collapsible: true,
			collapsed: true
		}]
	});*/
	var vp = new Ext.Viewport({
		layout: 'fit',
		items: [{xtype: 'app'}]
	})
});
